include:
  - project: 'clci/gitlab-ci'
    ref: v2-stable
    file:
      - guarded-linux-test-pipeline.gitlab-ci.yml
      - guarded-release-pipeline.gitlab-ci.yml
      - guarded-clpm-dep-update-pipeline.gitlab-ci.yml

# This section is not strictly required, but prevents Gitlab CI from launching
# multiple redundent pipelines when a Merge Request is opened.
workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS'
      when: never
    - if: '$CI_COMMIT_BRANCH'
    - if: '$CI_COMMIT_TAG'

variables:
  CLCI_TEST_ABCL: "no"
  CLCI_TEST_CLISP: "no"
  CLCI_TEST_CMUCL: "no"
  CLCI_ABCL_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/abcl
  CLCI_CCL_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/ccl
  CLCI_CLISP_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/clisp
  CLCI_CMUCL_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/cmucl
  CLCI_ECL_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/ecl
  CLCI_SBCL_IMAGE: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/clfoundation/sbcl

.common:test:clci:
  before_script:
    - apt-get update
    - apt-get install -y minizinc


build documentation:
  extends:
    - .clci clpm script
    - .clci sbcl
  variables:
    CLCI_SCRIPT: scripts/docs.lisp
  # This generates the doc folder as an artifact.
  artifacts:
    paths:
      - docs/
    expire_in: 1 week

pages:
  image: $CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX/alpine:latest
  script:
    - mv docs/ public/
    - ln -s odo.html public/index.html
  artifacts:
    paths:
      - public
    expire_in: 1 week
  needs:
    - build documentation
  only:
    - master
  except:
    - schedules
